<?php
/**
 * CodeIgniter
 *
 * An open source application development framework for PHP
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014 - 2017, British Columbia Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package	CodeIgniter
 * @author	EllisLab Dev Team
 * @copyright	Copyright (c) 2008 - 2014, EllisLab, Inc. (https://ellislab.com/)
 * @copyright	Copyright (c) 2014 - 2017, British Columbia Institute of Technology (http://bcit.ca/)
 * @license	http://opensource.org/licenses/MIT	MIT License
 * @link	https://codeigniter.com
 * @since	Version 1.0.0
 * @filesource
 */
defined('BASEPATH') OR exit('Doğrudan komut dosyası erişimine izin verilmez');

$lang['form_validation_required'] = '{field} alanı zorunludur.';
$lang['form_validation_isset'] = '{field} alanının bir değeri olmalıdır.';
$lang['form_validation_valid_email'] = '{field} alanı geçerli bir e-posta adresi içermelidir.';
$lang['form_validation_valid_emails'] = '{field} alanı tüm geçerli e-posta adreslerini içermelidir.';
$lang['form_validation_valid_url'] = '{field} alanı geçerli bir URL içermelidir.';
$lang['form_validation_valid_ip'] = '{field} alanı geçerli bir IP içermelidir.';
$lang['form_validation_valid_mac']		= 'The {field}, geçerli bir MAC adresi içermelidir.';
$lang['form_validation_valid_base64']		= 'The {field} alaın geçerli bir Base64 dizisi içermelidir.';
$lang['form_validation_min_length'] = '{field} alanı en az {param} karakter uzunluğunda olmalıdır.';
$lang['form_validation_max_length'] = '{field} alanının uzunluğu {param} karakteri aşamaz.';
$lang['form_validation_exact_length'] = '{field} alanı tam olarak {param} karakter uzunluğunda olmalıdır.';
$lang['form_validation_alpha'] = '{field} alanı yalnızca alfabetik karakterler içerebilir.';
$lang['form_validation_alpha_numeric'] = '{field} alanı yalnızca alfasayısal karakterler içerebilir.';
$lang['form_validation_alpha_numeric_spaces'] = '{field} alanı yalnızca alfasayısal karakterler ve boşluklar içerebilir.';
$lang['form_validation_alpha_dash'] = '{field} alanı yalnızca alfasayısal karakterler, alt çizgiler ve tireler içerebilir.';
$lang['form_validation_numeric'] = '{field} alanı sadece sayıları içermelidir.';
$lang['form_validation_is_numeric'] = '{field} alanı yalnızca sayısal karakterler içermelidir.';
$lang['form_validation_integer'] = '{field} alanı bir tamsayı içermelidir.';
$lang['form_validation_regex_match'] = '{field} alanı doğru biçimde değil.';
$lang['form_validation_matches'] = '{field} alanı, {param} alanıyla eşleşmiyor.';
$lang['form_validation_differs'] = '{field} alanı, {param} alanından farklı olmalıdır.';
$lang['form_validation_is_unique'] = '{field} alanı benzersiz bir değer içermelidir.';
$lang['form_validation_is_natural'] = '{field} alanı sadece rakam içermelidir.';
$lang['form_validation_is_natural_no_zero'] = '{field} alanı sadece rakam içermeli ve sıfırdan büyük olmalıdır.';
$lang['form_validation_decimal'] = '{field} alanı bir ondalık sayı içermelidir.';
$lang['form_validation_less_than'] = '{field} alanı, {param}\'dan küçük bir sayı içermelidir.';
$lang['form_validation_less_than_equal_to'] = '{field} alanı, {param}\'dan küçük veya ona eşit bir sayı içermelidir.';
$lang['form_validation_greer_than'] = '{field} alanı, {param}\'dan büyük bir sayı içermelidir.';
$lang['form_validation_greter_than_equal_to'] = '{field} alanı, {param}\'dan büyük veya ona eşit bir sayı içermelidir.';
$lang['form_validation_error_message_not_set'] = '{field} alan adınıza karşılık gelen bir hata mesajına erişilemiyor.';
$lang['form_validation_in_list'] = '{field} alanı şunlardan biri olmalıdır: {param}.';
